#include "AzureusStat.h"

int initModuleEx(HWND hParent, HINSTANCE hInst, LPCSTR pszPath)
{
	hwndParent = hParent;
	hInstance = hInst;

	WNDCLASS wc = { 0 };
	wc.lpfnWndProc = WndProc;
	wc.hInstance = hInst;
	wc.lpszClassName = szAppName;
	
	RegisterClass(&wc);

	hwndMain = CreateWindowEx(WS_EX_TOOLWINDOW, szAppName, NULL, WS_POPUP, 0, 0, 0, 0, NULL, NULL, hInst, NULL);
	SendMessage(hwndParent, LM_REGISTERMESSAGE, (WPARAM)hwndMain, (LPARAM)msgs);

	azureusActive = FALSE;

	readSettings();
	strcpy(szSeedNum, "0");
	strcpy(szDownNum, "0");
	strcpy(szDownSpeed, "0B/s");
	strcpy(szUpSpeed, "0B/s");
	ParsedPattern = parseLabelPattern();
	std::string LabelName(szLabelName);
	SetLabelText(LabelName, ParsedPattern);

	///
	// Add bang commands here
	///
	return 0;
}

void quitModule(HINSTANCE hInst)
{
	SendMessage(hwndParent, LM_UNREGISTERMESSAGE, (WPARAM)hwndMain, (LPARAM)msgs);
	DestroyWindow(hwndMain);
	UnregisterClass(szAppName, hInst);

	///
	// Remove bang commands here
	///
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
	switch (msg) {
		case LM_GETREVID: {
			if (wParam == 0 || wParam == 1) {
				LPSTR buf = (LPSTR)lParam;
				strcpy(buf, szVersion);
                return strlen(buf);
            }
			return 0;
		}
		break;

        case LM_REFRESH: {
			readSettings();
			if (!azureusActive) {
				strcpy(szSeedNum, "0");
				strcpy(szDownNum, "0");
				strcpy(szDownSpeed, "0B/s");
				strcpy(szUpSpeed, "0B/s");
				ParsedPattern = parseLabelPattern();
				std::string LabelName(szLabelName);
				SetLabelText(LabelName, ParsedPattern);
			}
        }
		break;
		
		case LM_SYSTRAY: {
			char szTip[TRAY_MAX_TIP_LENGTH];
			LSNOTIFYICONDATA* nid = (LSNOTIFYICONDATA*)lParam;
			strcpy(szTip, nid->szTip);
			int strLength = (int)strlen(szTip);
			if (strLength > 0) {
				if ((strstr(szTip, ", D: ") != NULL) && (strstr(szTip, ", U: ") != NULL)) {
					switch(wParam) {
						case NIM_MODIFY: {
							azureusActive = TRUE;
							char seps[] = " ";
							char *token;
							char *words[10];
							int n = 0;
							token = strtok(szTip, seps);
							while( token != NULL ) {
								words[n] = token;
								n++;
								token = strtok(NULL, seps);
							}
							(words[6])[strlen(words[6])-1] = '\0';
							strcpy(szSeedNum, words[0]);
							strcpy(szDownNum, words[2]);
							strcpy(szDownSpeed, words[5]);
							strcat(szDownSpeed, words[6]);
							strcpy(szUpSpeed, words[8]);
							strcat(szUpSpeed, words[9]);
							ParsedPattern = parseLabelPattern();
							std::string LabelName(szLabelName);
							SetLabelText(LabelName, ParsedPattern);
							break;
						}
						case NIM_DELETE: {
							azureusActive = FALSE;
							strcpy(szSeedNum, "0");
							strcpy(szDownNum, "0");
							strcpy(szDownSpeed, "0B/s");
							strcpy(szUpSpeed, "0B/s");
							ParsedPattern = parseLabelPattern();
							std::string LabelName(szLabelName);
							SetLabelText(LabelName, ParsedPattern);
							break;
						}
					}
				}
			}
		}
        break;
	}
	return DefWindowProc(hwnd, msg, wParam, lParam);
}

void readSettings(void) {
	GetRCString("AzLabelName", szLabelName, "", MAX_LINE_LENGTH);
	GetRCString("AzLabelPattern", szLabelPattern, "", MAX_LINE_LENGTH);
}

std::string parseLabelPattern() {
	std::string pattern(szLabelPattern);
	string search[] = {
		"%down_num",
		"%seed_num",
		"%down_spd",
		"%up_spd"
	};
	string replace[] = { 
		szDownNum,
		szSeedNum,
		szDownSpeed,
		szUpSpeed
	};
	int x;
	for (x = 0; x < VARIABLES; x++) {
		int varPos = -1;
		while ((varPos = (int)pattern.find(search[x],0)) != string::npos) {
			pattern.replace(varPos, search[x].size(), replace[x]);
		}
	}
	return pattern;
}


void SetLabelText(string sLabelName, string sValue)
{
	static HWND hwndLitestep = GetLitestepWnd();

	SETLABELTEXTINFO slti;
	slti.sName = sLabelName;
	slti.sValue = sValue;
	EnumWindows(LabelSearchProc, (LPARAM)&slti);
}

BOOL CALLBACK LabelSearchProc(HWND hwnd, LPARAM lParam)
{
	char buf[MAX_LINE_LENGTH], buf2[MAX_LINE_LENGTH];
	if (GetWindowText(hwnd, buf, MAX_LINE_LENGTH))
	{
		if (buf == ((LPSETLABELTEXTINFO)lParam)->sName )
		{
			if (GetClassName(hwnd, buf2, MAX_LINE_LENGTH))
			{
				if (stricmp(buf2,"xLabel") == 0 || stricmp(buf2, "LabelLS") == 0)
				{
					SendMessage(hwnd, LM_SETLABELTEXT, 0, (LPARAM)(((LPSETLABELTEXTINFO)lParam)->sValue).c_str());
					return FALSE;
				}
			}
		}
	}
	EnumChildWindows(hwnd, LabelSearchProc, lParam);
	return TRUE;
}